diff --git a/doc/guix.texi b/doc/guix.texi
index 293c3016aa..7a86501e60 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -28123,7 +28123,7 @@ Monitoring Services
 Darkstat is a packet sniffer that captures network traffic, calculates
 statistics about usage, and serves reports over HTTP.
 
-@defvar {Scheme Variable} darkstat-service-type
+@defvar darkstat-service-type
 This is the service type for the
 @uref{https://unix4lyfe.org/darkstat/, darkstat}
 service,  its value must be a @code{darkstat-configuration} record as in
@@ -28168,7 +28168,7 @@ Monitoring Services
 This service should be deployed on all physical nodes and virtual machines,
 where monitoring these statistics is desirable.
 
-@defvar {Scheme variable} prometheus-node-exporter-service-type
+@defvar prometheus-node-exporter-service-type
 This is the service type for the
 @uref{https://github.com/prometheus/node_exporter/, prometheus-node-exporter}
 service, its value must be a @code{prometheus-node-exporter-configuration}.
@@ -28213,7 +28213,7 @@ Monitoring Services
 data sources are supported, such as @ref{prometheus-node-exporter,
 Prometheus Node Exporter}).
 
-@defvar {Scheme variable} zabbix-server-service-type
+@defvar zabbix-server-service-type
 This is the service type for the Zabbix server service.  Its value must be a
 @code{zabbix-server-configuration} record, shown below.
 @end defvar
@@ -28299,7 +28299,7 @@ Monitoring Services
 @uref{https://www.zabbix.com/documentation/current/en/manual/config/items/userparameters,
 @dfn{user parameters}}.
 
-@defvar {Scheme variable} zabbix-agent-service-type
+@defvar zabbix-agent-service-type
 This is the service type for the Zabbix agent service.  Its value must be a
 @code{zabbix-agent-configuration} record, shown below.
 @end defvar
@@ -28376,7 +28376,7 @@ Monitoring Services
 extending the @ref{PHP-FPM} and @ref{NGINX} services with the configuration
 necessary for loading the Zabbix user interface.
 
-@defvar {Scheme variable} zabbix-front-end-service-type
+@defvar zabbix-front-end-service-type
 This is the service type for the Zabbix web frontend.  Its value must be a
 @code{zabbix-front-end-configuration} record, shown below.
 @end defvar
@@ -31396,7 +31396,7 @@ VNC Services
 can run on headless servers.  The Xvnc implementations provided by the
 @code{tigervnc-server} and @code{turbovnc} aim to be fast and efficient.
 
-@defvar {Scheme Variable} xvnc-service-type
+@defvar xvnc-service-type
 
 The @code{xvnc-server-type} service can be configured via the
 @code{xvnc-configuration} record, documented below.  A second virtual
@@ -32098,7 +32098,7 @@ Samba Services
 hosts in an heterougenious network with different types of Computer
 systems.
 
-@defvar {Scheme variable} samba-service-type
+@defvar samba-service-type
 
 The service type to enable the samba services @code{samba}, @code{nmbd},
 @code{smbd} and @code{winbindd}.  By default this service type does not
@@ -36266,7 +36266,7 @@ Game Services
 based tactical strategy game, with several single player campaigns, and
 multiplayer games (both networked and local).
 
-@defvar {Scheme Variable} wesnothd-service-type
+@defvar wesnothd-service-type
 Service type for the wesnothd service.  Its value must be a
 @code{wesnothd-configuration} object.  To run wesnothd in the default
 configuration, instantiate it as:
@@ -36297,7 +36297,7 @@ PAM Mount Service
 users to mount volumes when they log in.  It should be able to mount any
 volume format supported by the system.
 
-@defvar {Scheme Variable} pam-mount-service-type
+@defvar pam-mount-service-type
 Service type for PAM Mount support.
 @end defvar
 
@@ -36392,7 +36392,7 @@ Guix Services
 Coordinator, but the Guix service uses a custom Guile script instead, to
 provide better integration with G-expressions used in the configuration.
 
-@defvar {Scheme Variable} guix-build-coordinator-service-type
+@defvar guix-build-coordinator-service-type
 Service type for the Guix Build Coordinator.  Its value must be a
 @code{guix-build-coordinator-configuration} object.
 @end defvar
@@ -36441,7 +36441,7 @@ Guix Services
 @end table
 @end deftp
 
-@defvar {Scheme Variable} guix-build-coordinator-agent-service-type
+@defvar guix-build-coordinator-agent-service-type
 Service type for a Guix Build Coordinator agent.  Its value must be a
 @code{guix-build-coordinator-agent-configuration} object.
 @end defvar
@@ -36567,7 +36567,7 @@ Guix Services
 that may be useful when building derivations contained within an
 instance of the Guix Data Service.
 
-@defvar {Scheme Variable} guix-build-coordinator-queue-builds-service-type
+@defvar guix-build-coordinator-queue-builds-service-type
 Service type for the
 guix-build-coordinator-queue-builds-from-guix-data-service script.  Its
 value must be a @code{guix-build-coordinator-queue-builds-configuration}
@@ -36620,7 +36620,7 @@ Guix Services
 The data is stored in a PostgreSQL database, and available through a web
 interface.
 
-@defvar {Scheme Variable} guix-data-service-type
+@defvar guix-data-service-type
 Service type for the Guix Data Service.  Its value must be a
 @code{guix-data-service-configuration} object.  The service optionally
 extends the getmail service, as the guix-commits mailing list is used to
@@ -36668,7 +36668,7 @@ Guix Services
 The @uref{https://git.cbaines.net/guix/nar-herder/about/,Nar Herder} is
 a utility for managing a collection of nars.
 
-@defvar {Scheme Variable} nar-herder-type
+@defvar nar-herder-type
 Service type for the Guix Data Service.  Its value must be a
 @code{nar-herder-configuration} object.  The service optionally
 extends the getmail service, as the guix-commits mailing list is used to